#include "topwin.h"
#include <iostream>

TopWin::TopWin() :
  Gtk::Window(),
  d_popup_win(Gtk::WINDOW_POPUP)
{
  // by default d_popup_win is not fullscreen nor hidden
  is_fullscreen = false;
  is_hide = false;
  
  //set d_popup_win properties
  d_popup_win.set_size_request(200, 200);
  d_popup_win.set_modal(false);
      
  d_drawingarea.set_events(Gdk::BUTTON_PRESS_MASK);
  d_drawingarea.signal_button_press_event().connect(sigc::mem_fun(*this, &TopWin::onDrawingAreaClicked));
  
  set_size_request(300, 300);
  set_title("Fullscreen test");
  
  add(d_drawingarea);
  
  show_all_children();
}

TopWin::~TopWin() {

}

bool TopWin::onDrawingAreaClicked(GdkEventButton* event) {

  // if we got a double click 
  // then check and see whether should we fullscreen()
  // or unfullscreen() the main window
  if ((event->type == GDK_2BUTTON_PRESS) && (event->button == 1)) {
    std::cout << "Double Clicked!!" << std::endl;
  
    if (is_fullscreen) {
      // window is now no longer fullscreen 
      is_fullscreen = false;
      unfullscreen();
      
      // hide d_popup_win when unfullscreen
      // d_popup_win only show in fullscreen mode
      is_hide = true;
      d_popup_win.hide();
    }
    
    else {
      // window is now fullscreen
      fullscreen();
      is_fullscreen = true;
      
      // show d_popup_win when fullscreen
      // d_popup_win only show in fullscreen mode
      is_hide = false;
      d_popup_win.show_all_children();
      
      // run d_popup_win
      Gtk::Main::run(d_popup_win);
    }
  
    return true;
  }
  
  // if we got a right click
  // and if we are in fullscreen mode
  // check and see whether we should 
  // show() or hide() the d_popup_win
  else if ((event->type == GDK_BUTTON_PRESS) && (event->button == 3)) {
    if (is_fullscreen) {
    // if we are in fullscreen mode...
    
      if (is_hide) {
        // ...and d_popup_win is hidden then show d_popup_win
        d_popup_win.show();
        is_hide = false;
      }
      
      else {
        // ...and d_pop_win is shown then hide d_popup_win
        d_popup_win.hide();
        is_hide = true;
      }
    }
    
    return true;
  }
  
  else {
    return false;
  }
}
